/*!
 *  v1.1.2 - 2015-09-15 - Bootloader.js is a script and resource loader for caching and loading using localStorage.
 *
 * https://github.com/eskypl/Bootloader.js
 *
 * Copyright 2015 [object Object]
 * Released under the MIT license.
 */

!function(a,b){"use strict";"function"==typeof define&&define.amd?define([],b):a.Bootloader=b(a)}(this,function(a){"use strict";var b={prefix:"BL.",lifeTime:432e5,noRequireWaitTime:1e4,cookieName:"firstLoadBL",cookieExpires:432e5,iframeUrl:!1,iframeOrigin:!1},c=function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c]);return a},d={};try{a.console||(a.console={log:function(){},debug:function(){},info:function(){},warn:function(){},error:function(){}}),d=console}catch(e){}var f=!0;try{a.localStorage["BL.checkStorage"]=1,delete a.localStorage["BL.checkStorage"]}catch(e){f=!1}var g,h=f?h||a.localStorage:{},i=function(a,c){if(!f)return!1;var e=+new Date;try{return h[b.prefix+a]=JSON.stringify({data:c,expiration:e+b.lifeTime}),!0}catch(g){if(g&&g.name.toUpperCase().indexOf("QUOTA")>=0){var j,k=[];for(j in h)h.hasOwnProperty(j)&&-1!==j.indexOf(b.prefix)&&k.push({key:j,value:JSON.parse(h[j])});return k.length?(k.sort(function(a,b){return a.value.expiration-b.value.expiration}),delete h[k[0].key],i(a,c)):!0}return d.error('Cache: could not add item with key "'+a+'".',g.message),!1}},j=function(){if(!f)return!1;var a,c=+new Date;for(a in h)if(h.hasOwnProperty(a)&&-1!==a.indexOf(b.prefix)){var d=JSON.parse(h[a]);d.expiration<c&&delete h[a]}return!0},k=!1,l=[],m=!1,n=function(a){var b=document.createElement("a");return b.href=a,b},o=function(){var c=document.getElementById("bootloader-frame"),d=!!c;if(d)return c.contentWindow;var e=document.createElement("iframe");e.frameBorder=0,e.id="bootloader-frame",b.iframeOrigin&&(e.name=b.iframeOrigin),e.style.display="none",document.body.appendChild(e),e.onload=function(){k=e.contentWindow,a.bl&&a.bl.emit("saveCross")},e.src=b.iframeUrl},p=function(c,e){return m||(m=b.iframeUrl?n(b.iframeUrl):!1),"postMessage"in a&&k&&m?void k.postMessage(JSON.stringify({setStorage:!0,hash:c,data:e}),m.protocol+"//"+m.hostname):(d.error("Bootloader: blocked postData."),!1)},q=function(a,b){var c=0,d=+new Date,e=function(a,b){var f=new XMLHttpRequest;f.open("GET",a.url+(-1!==a.url.indexOf("?")?"."+d:"?timestamp="+d),!0),f.withCredentials=!0,f.onload=function(){f.status>=200&&f.status<400&&b(a,f.responseText),c=0},f.onerror=function(){c++,5>c&&e(a,b)},f.send()};return e(a,b)},r=function(a,b,c){var d;if(c){var e=new Date;e.setTime(e.getTime()+60*c*60*1e3),d="; expires="+e.toGMTString()}else d="";document.cookie=a+"="+b+d+"; path=/"},s=document.head||document.getElementsByTagName("head")[0],t=!1,u=function(a){return f||d.error("Bootloader: localStorage is disabled."),new u.fn.init(a)};return u.fn=u.prototype={constructor:u,options:b},u.fn.init=function(d){d=d||!1;var e=this;return d&&(this.options=c(b,d)),this.events={},this.toCache=[{require:0}],j(),this.on("grab",function(){this.getResource(1)}),this.on("saveCross",function(){if(!b.iframeUrl||b.iframeUrl&&!k)return!1;for(var a,c=0;a=l[c++];)a.save||(p(a.hash,a.response),a.save=!0)}),this.on("loadNoRequire",function(){f&&setTimeout(function(){e.getResource(0)},b.noRequireWaitTime)}),e.getToLoaded("css"),document.addEventListener?document.addEventListener("DOMContentLoaded",function(){b.iframeUrl&&o(),e.getToLoaded("js")},!1):a.attachEvent&&a.attachEvent("onreadystatechange",function(){b.iframeUrl&&o(),e.getToLoaded("js")}),t&&"complete"===document.readyState&&(b.iframeUrl&&o(),e.getToLoaded("js")),this},u.fn.init.prototype=u.fn,u.fn.on=function(a,b){return this.events[a]=this.events[a]||[],this.events[a].push({fn:b}),this},u.fn.emit=function(){for(var a,b=Array.apply([],arguments),c=this.events[b.shift()]||[],d=0;a=c[d++];)a.fn.apply(this,b)},u.fn.createElement=function(a,b){var c=document.createElement("js"===a?"script":"style");return c.type="js"===a?"text/javascript":"text/css",c["js"===a?"text":"innerHTML"]=b,c},u.fn.getToLoaded=function(a){"js"===a&&void 0===g&&(t=!0,g=document.body||document.getElementsByTagName("body")[0]);for(var b,c=document.querySelectorAll("js"===a?"script[data-src]":"style[data-url]"),d=0;b=c[d++];){var e=b.getAttribute("data-require");null!==e&&"1"===e&&this.toCache[0].require++,void 0!==b.isToCache||b.isToCache||(this.toCache.push({node:b,hash:b.getAttribute("data-hash"),cross:1*b.getAttribute("data-cross"),type:a,url:"js"===a?b.getAttribute("data-src"):b.getAttribute("data-url"),require:parseInt(null===e?0:e),fn:"js"===a?b.getAttribute("data-fn"):!1,isLoad:!1}),b.isToCache=!0)}this.emit("grab")},u.fn.getResource=function(a){a=a||0;for(var c,d=this,e=0,g=!0,j=function(a,b){return f?(a.cross&&(l.push({hash:a.hash,response:b,save:!1}),d.emit("saveCross")),i(a.hash,b),void(1===a.require&&d.appendResource(a,b))):void d.appendNoSupportStorage(a,b)},k=0;c=this.toCache[k++];){var m=f?h[b.prefix+c.hash]:!1,n=document.cookie.indexOf(b.cookieName);c.require===a&&c.node&&(!f&&-1===n&&!c.isLoad||void 0===m&&!c.isLoad||!m&&!c.isLoad&&-1!==n?(q(c,j),c.isLoad=!0,g&&(r(b.cookieName,"1",b.cookieExpires),g=!1)):1===c.require&&m&&(c.cross&&(l.push({hash:c.hash,response:JSON.parse(h[b.prefix+c.hash]).data,save:!1}),d.emit("saveCross")),d.appendResource(c,JSON.parse(h[b.prefix+c.hash]).data)),e++,1===a&&this.toCache[0].require===e&&d.emit("loadNoRequire"))}},u.fn.appendResource=function(b,c){"css"===b.type?b.node.innerHTML=c:(b.node.text=c,b.fn&&"function"==typeof a[b.fn]&&a[b.fn]())},u.fn.appendNoSupportStorage=function(b,c){var d=this,e=document.createDocumentFragment();e.appendChild(d.createElement(b.type,c)),("js"===b.type?g:s).appendChild(e),"js"===b.type&&b.fn&&"function"==typeof a[b.fn]&&a[b.fn]()},a.bl=new u(a.blConfig),u});